diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/TermUpdater_31_33.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/TermUpdater_31_33.java
new file mode 100644
index 0000000000..c97eb26cc2
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/TermUpdater_31_33.java
@@ -0,0 +1,184 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update.v31_33;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.UUID;
+
+import org.apache.log4j.Logger;
+
+import eu.etaxonomy.cdm.database.update.ITermUpdater;
+import eu.etaxonomy.cdm.database.update.ITermUpdaterStep;
+import eu.etaxonomy.cdm.database.update.SingleTermUpdater;
+import eu.etaxonomy.cdm.database.update.TermUpdaterBase;
+import eu.etaxonomy.cdm.database.update.v30_31.TermUpdater_314_315;
+import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.TermType;
+import eu.etaxonomy.cdm.model.name.NameRelationshipType;
+import eu.etaxonomy.cdm.model.name.NomenclaturalStatusType;
+import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.name.RankClass;
+
+/**
+ * @author a.mueller
+ * @date 10.09.2010
+ *
+ */
+public class TermUpdater_31_33 extends TermUpdaterBase implements ITermUpdater {
+	@SuppressWarnings("unused")
+	private static final Logger logger = Logger.getLogger(TermUpdater_31_33.class);
+	
+	public static final String startTermVersion = "3.0.1.5.201109280000";
+	private static final String endTermVersion = "3.3.0.0.201309240000";
+	
+// *************************** FACTORY **************************************/
+	
+	public static TermUpdater_31_33 NewInstance(){
+		return new TermUpdater_31_33(startTermVersion, endTermVersion);
+	}
+	
+// *************************** CONSTRUCTOR ***********************************/	
+
+	protected TermUpdater_31_33(String startTermVersion, String endTermVersion) {
+		super(startTermVersion, endTermVersion);
+	}
+	
+// 
+	
+	/* (non-Javadoc)
+	 * @see eu.etaxonomy.cdm.database.update.ICdmUpdater#invoke()
+	 */
+	@Override
+	protected List<ITermUpdaterStep> getUpdaterList() {
+		List<ITermUpdaterStep> list = new ArrayList<ITermUpdaterStep>();
+
+		// proles, #2793
+		UUID uuidTerm = UUID.fromString("8810d1ba-6a34-4ae3-a355-919ccd1cd1a5");
+		String description = "Rank ''Proles''. Note: This rank is not compliant with the current nomenclatural codes";
+		String label = "Proles";
+		String abbrev = "prol.";
+		String dtype = Rank.class.getSimpleName();
+		boolean isOrdered = true;
+		UUID uuidVocabulary = UUID.fromString("ef0d1ce1-26e3-4e83-b47b-ca74eed40b1b");
+		UUID uuidAfterTerm = UUID.fromString("bff22f84-553a-4429-a4e7-c4b3796c3a18");
+		UUID uuidLang = Language.uuidEnglish;
+		RankClass rankClass = RankClass.Infraspecific;
+		String stepName = "Add 'proles' rank to ranks";
+		TermType termType = TermType.Rank;
+		list.add( SingleTermUpdater.NewInstance(stepName, termType, uuidTerm, abbrev, description, label, abbrev, dtype, uuidVocabulary, uuidLang, isOrdered, uuidAfterTerm).setRankClass(rankClass));
+
+		// race, #2793
+		uuidTerm = UUID.fromString("196dee39-cfd8-4460-8bf0-88b83da27f62");
+		description = "Rank ''Race''. Note: This rank is not compliant with the current nomenclatural codes";
+		label = "Race";
+		abbrev = "race";
+		dtype = Rank.class.getSimpleName();
+		isOrdered = true;
+		uuidVocabulary = UUID.fromString("ef0d1ce1-26e3-4e83-b47b-ca74eed40b1b");
+		uuidAfterTerm = UUID.fromString("8810d1ba-6a34-4ae3-a355-919ccd1cd1a5");
+		uuidLang = Language.uuidEnglish;
+		rankClass = RankClass.Infraspecific;
+		stepName = "Add 'race' rank to ranks";
+		termType = TermType.Rank;
+		list.add( SingleTermUpdater.NewInstance(stepName, termType, uuidTerm, abbrev, description, label, abbrev, dtype, uuidVocabulary, uuidLang, isOrdered, uuidAfterTerm).setRankClass(rankClass));
+
+		// sublusus, #2793
+		uuidTerm = UUID.fromString("1fafa596-a8e7-4e62-a378-3cc8cb3627ca");
+		description = "Rank ''Sublusus''. Note: This rank is not compliant with the current nomenclatural codes";
+		label = "Sublusus";
+		abbrev = "sublusus";
+		dtype = Rank.class.getSimpleName();
+		isOrdered = true;
+		uuidVocabulary = UUID.fromString("ef0d1ce1-26e3-4e83-b47b-ca74eed40b1b");
+		uuidAfterTerm = UUID.fromString("196dee39-cfd8-4460-8bf0-88b83da27f62");
+		uuidLang = Language.uuidEnglish;
+		rankClass = RankClass.Infraspecific;
+		stepName = "Add 'sublusus' rank to ranks";
+		termType = TermType.Rank;
+		list.add( SingleTermUpdater.NewInstance(stepName, termType, uuidTerm, abbrev, description, label, abbrev, dtype, uuidVocabulary, uuidLang, isOrdered, uuidAfterTerm).setRankClass(rankClass));
+
+		// comb. nov., #3545
+		uuidTerm = UUID.fromString("ed508710-deef-44b1-96f6-1ce6d2c9c884");
+		description = "Nomenclatural status type ''new combination''";
+		label = "new combination";
+		abbrev = "comb. nov.";
+		dtype = NomenclaturalStatusType.class.getSimpleName();
+		isOrdered = true;
+		uuidVocabulary = UUID.fromString("bb28cdca-2f8a-4f11-9c21-517e9ae87f1f");
+		uuidAfterTerm = UUID.fromString("92a76bd0-6ea8-493f-98e0-4be0b98c092f");
+		uuidLang = Language.uuidLatin;
+		stepName = "Add 'comb. nov.' status to nom. status types";
+		termType = TermType.NomenclaturalStatusType;
+		list.add( SingleTermUpdater.NewInstance(stepName, termType, uuidTerm, abbrev, description, label, abbrev, dtype, uuidVocabulary, uuidLang, isOrdered, uuidAfterTerm));
+
+		// original spelling, #2874
+		uuidTerm = UUID.fromString("264d2be4-e378-4168-9760-a9512ffbddc4");
+		description = "Namerelationship type ''original spelling for''";
+		label = "original spelling for";
+		abbrev = null;
+		String reverseDescription = "has original spelling";
+		String reverseLabel = "has original spelling";
+		String reverseAbbrev = null;
+		dtype = NameRelationshipType.class.getSimpleName();
+		isOrdered = true;
+		uuidVocabulary = UUID.fromString("6878cb82-c1a4-4613-b012-7e73b413c8cd");
+		uuidAfterTerm = UUID.fromString("eeaea868-c4c1-497f-b9fe-52c9fc4aca53");
+		uuidLang = Language.uuidEnglish;
+		stepName = "Add 'original spelling for' name relationship name relationship types";
+		termType = TermType.NameRelationshipType;
+		boolean symmetric = false;
+		boolean transitive = false;
+		list.add( SingleTermUpdater.NewInstance(stepName, termType, uuidTerm, abbrev, description, 
+				label, abbrev, dtype, uuidVocabulary, uuidLang, isOrdered, uuidAfterTerm)
+				.setReverseRepresentation(reverseDescription, reverseLabel, reverseAbbrev)
+				.setSymmetricTransitiv(symmetric, transitive));
+
+		
+		// later isnonym, #2874
+		uuidTerm = UUID.fromString("29ab238d-598d-45b9-addd-003cf39ccc3e");
+		description = "Namerelationship type ''later isonym for''";
+		label = "later isonym for";
+		abbrev = null;
+		reverseDescription = "has earlier isonym";
+		reverseLabel = "has earlier isonym";
+		reverseAbbrev = null;
+		dtype = NameRelationshipType.class.getSimpleName();
+		isOrdered = true;
+		uuidVocabulary = UUID.fromString("6878cb82-c1a4-4613-b012-7e73b413c8cd");
+		uuidAfterTerm = UUID.fromString("2990a884-3302-4c8b-90b2-dfd31aaa2778");
+		uuidLang = Language.uuidEnglish;
+		stepName = "Add 'later isonym for' name relationship name relationship types";
+		termType = TermType.NameRelationshipType;
+		symmetric = false;
+		transitive = true;
+		list.add( SingleTermUpdater.NewInstance(stepName, termType, uuidTerm, abbrev, description, 
+				label, abbrev, dtype, uuidVocabulary, uuidLang, isOrdered, uuidAfterTerm)
+				.setReverseRepresentation(reverseDescription, reverseLabel, reverseAbbrev)
+				.setSymmetricTransitiv(symmetric, transitive));
+
+		
+		//there are some more new vocabularies, but we trust that the term initializer will 
+		//initialize and persist them correctly
+		
+		return list;
+	}
+	
+	@Override
+	public ITermUpdater getNextUpdater() {
+		return null;
+	}
+
+	@Override
+	public ITermUpdater getPreviousUpdater() {
+		return TermUpdater_314_315.NewInstance();
+	}
+
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/TermVocabularyRepresentationUpdater.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/TermVocabularyRepresentationUpdater.java
new file mode 100644
index 0000000000..21ab1de7d7
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/database/update/v31_33/TermVocabularyRepresentationUpdater.java
@@ -0,0 +1,113 @@
+// $Id$
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy 
+* http://www.e-taxonomy.eu
+* 
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.database.update.v31_33;
+
+import java.sql.SQLException;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.UUID;
+
+import org.apache.log4j.Logger;
+
+import au.com.bytecode.opencsv.CSVReader;
+
+import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
+import eu.etaxonomy.cdm.database.ICdmDataSource;
+import eu.etaxonomy.cdm.database.update.ITermUpdaterStep;
+import eu.etaxonomy.cdm.database.update.SchemaUpdaterStepBase;
+import eu.etaxonomy.cdm.model.common.DefinedTermBase;
+import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.Representation;
+import eu.etaxonomy.cdm.model.common.TermType;
+import eu.etaxonomy.cdm.model.common.TermVocabulary;
+import eu.etaxonomy.cdm.model.common.VocabularyEnum;
+import eu.etaxonomy.cdm.model.name.Rank;
+import eu.etaxonomy.cdm.model.name.RankClass;
+
+/**
+ * @author a.mueller
+ * @date 15.12.2013
+ */
+public class TermVocabularyRepresentationUpdater extends SchemaUpdaterStepBase<TermVocabularyRepresentationUpdater> implements ITermUpdaterStep{
+	private static final Logger logger = Logger.getLogger(TermVocabularyRepresentationUpdater.class);
+
+	private static final String stepName = "Update term vocabulary representations";
+	
+// **************************** STATIC METHODS ********************************/
+
+	public static final TermVocabularyRepresentationUpdater NewInstance(){
+		return new TermVocabularyRepresentationUpdater(stepName);	
+	}
+
+	protected TermVocabularyRepresentationUpdater(String stepName) {
+		super(stepName);
+	}
+
+	@Override
+	public Integer invoke(ICdmDataSource datasource, IProgressMonitor monitor) throws SQLException {
+		
+		try {
+			String sql = String.format(" SELECT id FROM DefinedTermBase dtb WHERE dtb.uuid = '%s'", Language.uuidEnglish);
+			String languageId = String.valueOf((Number)datasource.getSingleValue(sql));
+			
+			
+			//for each vocabulary
+			for(VocabularyEnum vocabularyEnum : VocabularyEnum.values()) {
+				//read vocabulary from terms files
+				String filename = vocabularyEnum.name()+".csv";
+				CSVReader reader = new CSVReader(CdmUtils.getUtf8ResourceReader("terms" + CdmUtils.getFolderSeperator() + filename));
+				String [] nextLine = reader.readNext();
+				TermVocabulary<?> voc = TermVocabulary.NewInstance(TermType.Unknown);
+				voc.readCsvLine(arrayedLine(nextLine));
+				
+				//get uuid, label and description for the vocabulary
+				UUID uuid = voc.getUuid();
+				Representation repEN = voc.getRepresentations().iterator().next();
+				String label = repEN.getLabel();
+				String description = repEN.getText();
+				
+				//find representation in database
+				sql = " SELECT rep.uuid " +
+						" FROM TermVocabulary voc INNER JOIN TermVocabulary_Representation MN ON MN.TermVocabulary_id = voc.id " +
+						" INNER JOIN Representation rep ON rep.id = MN.representations_id " +
+						" WHERE voc.uuid = '%s' AND rep.language_id = %s";
+				sql = String.format(sql, uuid.toString(), languageId);
+				String repUuid = (String)datasource.getSingleValue(sql);
+				
+				//update with correct label and representation
+				sql = " UPDATE Representation r SET label = '%s', text = '%s' WHERE r.uuid = '%s'";
+				sql = String.format(sql, label, description, repUuid);
+				datasource.executeUpdate(sql);
+				
+			}	
+			
+			
+			return 0;
+		} catch (Exception e) {
+			monitor.warning(e.getMessage(), e);
+			logger.warn(e.getMessage());
+			return null;
+		}
+	}
+	
+	private List<String> arrayedLine(String [] nextLine){
+		ArrayList<String> csvTermAttributeList = new ArrayList<String>(8);
+		for (String col : nextLine){
+			csvTermAttributeList.add(col);
+		}
+		while (csvTermAttributeList.size()<8){
+			csvTermAttributeList.add("");
+		}
+		return csvTermAttributeList;
+	}
+
+	
+}
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ICdmGenericDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ICdmGenericDao.java
index 10df7e0fdb..869038dce3 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ICdmGenericDao.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ICdmGenericDao.java
@@ -17,8 +17,8 @@ import java.util.UUID;
 import org.springframework.dao.DataAccessException;
 
 import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.common.CdmMetaData;
-import eu.etaxonomy.cdm.model.common.CdmMetaData.MetaDataPropertyName;
+import eu.etaxonomy.cdm.model.metadata.CdmMetaData;
+import eu.etaxonomy.cdm.model.metadata.CdmMetaData.MetaDataPropertyName;
 import eu.etaxonomy.cdm.strategy.match.IMatchStrategy;
 import eu.etaxonomy.cdm.strategy.match.IMatchable;
 import eu.etaxonomy.cdm.strategy.match.MatchException;
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IDefinedTermDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IDefinedTermDao.java
index fa1a72e711..84feffb277 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IDefinedTermDao.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IDefinedTermDao.java
@@ -14,13 +14,14 @@ import java.util.Enumeration;
 import java.util.List;
 import java.util.Locale;
 import java.util.Set;
+import java.util.UUID;
 
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.persistence.dao.IBeanInitializer;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
@@ -39,7 +40,7 @@ public interface IDefinedTermDao extends IIdentifiableDao<DefinedTermBase>, ITit
 
 	public List<Language> getLanguagesByLocale(Enumeration<Locale> locales);
 
-	public WaterbodyOrCountry getCountryByIso(String iso639);
+	public Country getCountryByIso(String iso639);
 
 	public <TYPE extends DefinedTermBase> List<TYPE> getDefinedTermByRepresentationText(String text, Class<TYPE> clazz );
 
@@ -162,4 +163,15 @@ public interface IDefinedTermDao extends IIdentifiableDao<DefinedTermBase>, ITit
 	public DefinedTermBase findByUri(URI uri);
 
 	public <TERM extends DefinedTermBase> List<TERM> listByTermClass(Class<TERM> clazz, Integer limit, Integer start, List<OrderHint> orderHints, List<String> propertyPaths);
+
+	/**
+	 * Returns a term or a list of terms depending of the label/id used in its vocabulary. 
+	 * @param idInVoc
+	 * @param vocUuid
+	 * @param clazz
+	 * @param pageSize
+	 * @param pageNumber
+	 * @return
+	 */
+	public <TERM extends DefinedTermBase> List<TERM> getDefinedTermByIdInVocabulary(String idInVoc, UUID vocUuid, Class<TERM> clazz, Integer pageSize, Integer pageNumber);
 }
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IPreferenceDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IPreferenceDao.java
new file mode 100644
index 0000000000..2463b71e65
--- /dev/null
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/IPreferenceDao.java
@@ -0,0 +1,38 @@
+/**
+* Copyright (C) 2009 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/ 
+package eu.etaxonomy.cdm.persistence.dao.common;
+
+import eu.etaxonomy.cdm.model.metadata.CdmPreference;
+
+/**
+ * @author a.mueller
+ * @created 2013-09-09
+ */
+public interface IPreferenceDao {
+
+	/**
+	 * Retrieve the value for the given preference key.
+	 * @param key
+	 * @return
+	 */
+	public CdmPreference get(CdmPreference.PrefKey key);
+
+	/**
+	 * Write the value for the preference's key
+	 * @param preference
+	 */
+	public void set(CdmPreference preference);
+
+	/**
+	 * Return the number of all existing cdm preferences
+	 * @return
+	 */
+	public int count();
+
+}
\ No newline at end of file
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ITermVocabularyDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ITermVocabularyDao.java
index 89ef8505af..efdc53d900 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ITermVocabularyDao.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/common/ITermVocabularyDao.java
@@ -13,6 +13,7 @@ package eu.etaxonomy.cdm.persistence.dao.common;
 import java.util.List;
 
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
 
@@ -42,6 +43,15 @@ public interface ITermVocabularyDao extends IIdentifiableDao<TermVocabulary> {
 	public <T extends DefinedTermBase> List<T> getTerms(TermVocabulary<T> termVocabulary, Integer pageSize, Integer pageNumber);
 	
 	public <T extends DefinedTermBase> TermVocabulary<T> findByUri(String termSourceUri, Class<T> clazz);
+	
+	/**
+	 * Return a List of vocabularies that belong to the term type supplied
+	 * 
+	 * @param termType The term type corresoponding to the vocabularies of interest
+	 * @return a List of vocabularies
+	 */
+	
+	public <T extends DefinedTermBase> List<TermVocabulary<T>> findByTermType(TermType termType);
 
 	/**
 	 * Return a List of terms that belong to the termVocabulary supplied
@@ -78,4 +88,6 @@ public interface ITermVocabularyDao extends IIdentifiableDao<TermVocabulary> {
 
 	
 	public List<TermVocabulary> listEmpty(Integer limit, Integer start,List<OrderHint> orderHints, List<String> propertyPaths);
+
+
 }
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/description/IDescriptionDao.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/description/IDescriptionDao.java
index 77f440d437..c1c955f802 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/description/IDescriptionDao.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/description/IDescriptionDao.java
@@ -13,13 +13,13 @@ import java.util.List;
 import java.util.Set;
 import java.util.UUID;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.MarkerType;
 import eu.etaxonomy.cdm.model.description.CommonTaxonName;
 import eu.etaxonomy.cdm.model.description.DescriptionBase;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
-import eu.etaxonomy.cdm.model.description.Scope;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
@@ -33,32 +33,43 @@ import eu.etaxonomy.cdm.persistence.query.MatchMode;
 import eu.etaxonomy.cdm.persistence.query.OrderHint;
 
 public interface IDescriptionDao extends IIdentifiableDao<DescriptionBase> {
-    /**
-     * List the descriptions of type <TYPE>, filtered using the following parameters
-     *
-     * @param type The type of description returned (Taxon, TaxonName, or Specimen)
-     * @param hasMedia Restrict the description to those that do (true) or don't (false) contain <i>elements</i> that have one or more media (can be null)
-     * @param hasText Restrict the description to those that do (true) or don't (false) contain TextData <i>elements</i> that have some textual content (can be null)
-     * @param feature Restrict the description to those <i>elements</i> which are scoped by one of the Features passed (can be null or empty)
-     * @param pageSize The maximum number of descriptions returned (can be null for all descriptions)
-     * @param pageNumber The offset (in pageSize chunks) from the start of the result set (0 - based)
-     * @param orderHints may be null
-     * @param propertyPaths properties to initialize - see {@link IBeanInitializer#initialize(Object, List)}
-     * @return a List of DescriptionBase instances
-     */
-     List<DescriptionBase> listDescriptions(Class<? extends DescriptionBase> type, Boolean hasMedia, Boolean hasText, Set<Feature> feature, Integer pageSize, Integer pageNumber, List<OrderHint> orderHints, List<String> propertyPaths);
-
-    /**
-     * Count the descriptions of type <TYPE>, filtered using the following parameters
-     *
-     * @param type The type of description returned (Taxon, TaxonName, or Specimen)
-     * @param hasMedia Restrict the description to those that do (true) or don't (false) contain <i>elements</i> that have one or more media (can be null)
-     * @param hasText Restrict the description to those that do (true) or don't (false) contain TextData <i>elements</i> that have some textual content (can be null)
-     * @param feature Restrict the description to those <i>elements</i> which are scoped by one of the Features passed (can be null or empty)
-     * @return a count of DescriptionBase instances
-     */
-     int countDescriptions(Class<? extends DescriptionBase> type, Boolean hasImages, Boolean hasText, Set<Feature> feature);
-
+	/**
+	 * List the descriptions of type <TYPE>, filtered using the following parameters
+	 *  
+	 * @param type The type of description returned (Taxon, TaxonName, or Specimen)
+	 * @param hasMedia Restrict the description to those that do (true) or don't (false) contain <i>elements</i> that have one or more media (can be null)
+	 * @param hasText Restrict the description to those that do (true) or don't (false) contain TextData <i>elements</i> that have some textual content (can be null)
+	 * @param feature Restrict the description to those <i>elements</i> which are scoped by one of the Features passed (can be null or empty)
+	 * @param pageSize The maximum number of descriptions returned (can be null for all descriptions)
+	 * @param pageNumber The offset (in pageSize chunks) from the start of the result set (0 - based)
+	 * @param orderHints may be null
+	 * @param propertyPaths properties to initialize - see {@link IBeanInitializer#initialize(Object, List)}
+	 * @return a List of DescriptionBase instances
+	 */
+	 List<DescriptionBase> listDescriptions(Class<? extends DescriptionBase> type, Boolean hasMedia, Boolean hasText, Set<Feature> feature, Integer pageSize, Integer pageNumber, List<OrderHint> orderHints, List<String> propertyPaths);
+	
+	/**
+	 * Count the descriptions of type <TYPE>, filtered using the following parameters
+	 * 
+	 * @param type The type of description returned (Taxon, TaxonName, or Specimen)
+	 * @param hasMedia Restrict the description to those that do (true) or don't (false) contain <i>elements</i> that have one or more media (can be null)
+	 * @param hasText Restrict the description to those that do (true) or don't (false) contain TextData <i>elements</i> that have some textual content (can be null)
+	 * @param feature Restrict the description to those <i>elements</i> which are scoped by one of the Features passed (can be null or empty)
+	 * @return a count of DescriptionBase instances
+	 */
+	 int countDescriptions(Class<? extends DescriptionBase> type, Boolean hasImages, Boolean hasText, Set<Feature> feature);
+	
+	/**
+	 * Returns a count of TaxonDescription instances, optionally filtered by parameters passed to this method
+	 * 
+	 * @param taxon Restrict the results to those descriptions that refer to a specific taxon (can be null for all TaxonDescription instances)
+	 * @param scopes Restrict the results to those descriptions which are scoped by one of the Scope instances passed (can be null or empty)
+	 * @param geographicalScope Restrict the results to those descriptions which have a geographical scope that overlaps with the NamedArea instances passed (can be null or empty)
+	 * @param markerType Restrict the results to those descriptions which are marked as true by one of the given marker types (can be null or empty)
+	 * @return a count of TaxonDescription instances
+	 */
+	int countTaxonDescriptions(Taxon taxon, Set<DefinedTerm> scopes, Set<NamedArea> geographicalScope, Set<MarkerType> markerType);
+	
     /**
      * Returns description elements of type <TYPE>, belonging to a given description, optionally filtered by one or more features
      *
@@ -133,7 +144,7 @@ public interface IDescriptionDao extends IIdentifiableDao<DescriptionBase> {
      *            The type of description
      * @return a count of DescriptionElementBase instances
      */
-      int countDescriptionElements(DescriptionBase description, Class<? extends DescriptionBase> descriptionType, Set<Feature> features, Class<? extends DescriptionElementBase> type);
+    int countDescriptionElements(DescriptionBase description, Class<? extends DescriptionBase> descriptionType, Set<Feature> features, Class<? extends DescriptionElementBase> type);
 
     /**
      * Returns a List of TaxonDescription instances, optionally filtered by parameters passed to this method
@@ -147,20 +158,7 @@ public interface IDescriptionDao extends IIdentifiableDao<DescriptionBase> {
      * @param propertyPaths Properties to initialize in the returned entities, following the syntax described in {@link IBeanInitializer#initialize(Object, List)}
      * @return a List of TaxonDescription instances
      */
-    List<TaxonDescription> listTaxonDescriptions(Taxon taxon, Set<Scope> scopes, Set<NamedArea> geographicalScope, Set<MarkerType> markerTypes, Integer pageSize, Integer pageNumber, List<String> propertyPaths);
-
-
-    /**
-     * Returns a count of TaxonDescription instances, optionally filtered by parameters passed to this method
-     *
-     * @param taxon Restrict the results to those descriptions that refer to a specific taxon (can be null for all TaxonDescription instances)
-     * @param scopes Restrict the results to those descriptions which are scoped by one of the Scope instances passed (can be null or empty)
-     * @param geographicalScope Restrict the results to those descriptions which have a geographical scope that overlaps with the NamedArea instances passed (can be null or empty)
-     * @param markerType Restrict the results to those descriptions which are marked as true by one of the given marker types (can be null or empty)
-     * @return a count of TaxonDescription instances
-     */
-    int countTaxonDescriptions(Taxon taxon, Set<Scope> scopes, Set<NamedArea> geographicalScope, Set<MarkerType> markerType);
-
+    List<TaxonDescription> listTaxonDescriptions(Taxon taxon, Set<DefinedTerm> scopes, Set<NamedArea> geographicalScope, Set<MarkerType> markerTypes, Integer pageSize, Integer pageNumber, List<String> propertyPaths);
 
     /**
      * Returns a List of Media instances, optionally filtered by parameters passed to this method.
diff --git a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/CdmGenericDaoImpl.java b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/CdmGenericDaoImpl.java
index 6ac4febf21..3b89cbff95 100644
--- a/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/CdmGenericDaoImpl.java
+++ b/cdmlib-persistence/src/main/java/eu/etaxonomy/cdm/persistence/dao/hibernate/common/CdmGenericDaoImpl.java
@@ -73,11 +73,11 @@ import eu.etaxonomy.cdm.hibernate.WSDLDefinitionUserType;
 import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.common.CdmMetaData;
 import eu.etaxonomy.cdm.model.common.Extension;
 import eu.etaxonomy.cdm.model.common.ICdmBase;
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.Marker;
+import eu.etaxonomy.cdm.model.metadata.CdmMetaData;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
